#include "sysgen.h"
#include <math.h>
#include <stdio.h>
#ifdef min
#undef min
#endif min

body   *print();
body   *pdlevel();
extern sistem  syst;

void   map(s, plate, land, cov)
body   *s;
int    plate[20][28];
int    land[20][28];
int    cov[20][28];
{
       int     t, h;
       int     i, l;
       int     scale;
       char    c;
       int     buf[6][2];
       long    tmp;
       dworld  *d;

       xyzmagic(syst.x, syst.y, syst.z, MAP_MAGIC);
       d = &s->det.w;
       for (t = 0; t < 20; t++)
               for (h = 0; h < 28; h++)
                       plate[t][h] = 0;
fprintf(stderr, "%s:", s->name);
       plates(plate, d->nplates);
fprintf(stderr, ".");
       if (d->water < 50)
               seas(plate, land, d->arch, d->isl, d->min,
                       d->maj, d->water);
       else
               lands(plate, land, d->arch, d->isl, d->min,
                       d->maj, 100 - d->water);
fprintf(stderr, ".");
       cover(cov, land, plate, s);
fprintf(stderr, ".\n");
}

body   *makemap(x, y, z, name, plates, land, cov)
long   x, y, z;
char   *name;
int    plates[20][28];
int    land[20][28];
int    cov[20][28];
{
       if (makedetails(&syst, x, y, z) == 0)
               return(0);
       return(print(&syst, name, plates, land, cov));
}

body   *print(syst, name, plates, land, cov)
sistem *syst;
char   *name;
int    plates[20][28];
int    land[20][28];
int    cov[20][28];
{
       printf("%s system\n", syst->mw->name);
       printf("Location %ld,%ld,%ld\n", syst->x, syst->y, syst->z);
       return(pdlevel(syst->sys, name, plates, land, cov));
}

body   *pdlevel(s, name, plates, land, cov)
body   *s;
char   *name;
int    plates[20][28];
int    land[20][28];
int    cov[20][28];
{
       body    *ret;
       int     i;

       if (!s)
               return(s);
       if (!strcmp(s->name, name))
       {
               if ((s->type == T_WORLD) || (s->type == T_MAIN))
                       map(s, plates, land, cov);
               else
                       printf("Can only map worlds\n");
               return(s);
       }
       if (!s->b)
               return(0);
       for (s = s->b; s; s = s->o)
       {
               ret = pdlevel(s, name, plates, land, cov);
               if (ret)
                       break;
       }
       return(ret);
}
